#include <FastLED.h>
int light = 0;
int r = 9; // define pins
int g = 10;
int b = 11;
int oldavg = 0;
void setup() {
  Serial.begin(9600);
  pinMode(13, OUTPUT);
}

void loop() {
  int ss = 20; // sample size for light sensor
  int average = 0;
  for (int x = 0; x < ss; x++) {
    //average += 256-log(256-analogRead(0) / 4) * (256 /5.55); // old linearization

    // linearization using resistance to lux relationship 
    average += (1250000.0 * pow(1023 - analogRead(0), -1.4059) - 73) / 2.08;
    delay(3);
  }
  average /= ss;
  //Serial.println(average);
  if (oldavg == 0) {
    oldavg = average;
  }
  digitalWrite(13, HIGH);
  if (oldavg != average) {
    Serial.print("Goal: ");
    Serial.println(average);
  }
  while (oldavg < average) {
    oldavg += 1;
    setColor(oldavg);
  }
  while (oldavg > average) {
    oldavg -= 1;
    setColor(oldavg);
  }
  digitalWrite(13, LOW);
}

void setColor(int hue) {
  CRGB color = CHSV(hue, 255, 255);
  analogWrite(9, color.r);
  analogWrite(10, color.g);
  analogWrite(11, color.b);
  Serial.print("Hue: ");
  Serial.print(hue);
  Serial.print(", RGB : ");
  Serial.print(color.r);
  Serial.print(", ");
  Serial.print(color.g);
  Serial.print(", ");
  Serial.println(color.b);
}
